com.fasterxml.jackson.databind.type

## Class MapLikeType

- java.lang.Object
- - com.fasterxml.jackson.core.type.ResolvedType
  - - com.fasterxml.jackson.databind.JavaType
    - - com.fasterxml.jackson.databind.type.TypeBase
      - - com.fasterxml.jackson.databind.type.MapLikeType

- All Implemented Interfaces:
    JsonSerializable, Serializable, Type
  Direct Known Subclasses:
    MapType

      public class MapLikeType
      extends TypeBase

  Type that represents Map-like types; things that consist of key/value pairs but that do not necessarily implement `Map`, but that do not have enough introspection functionality to allow for some level of generic handling. This specifically allows framework to check for configuration and annotation settings used for Map types, and pass these to custom handlers that may be more familiar with actual type.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface com.fasterxml.jackson.databind.JsonSerializable

      `JsonSerializable.Base`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected JavaType` | `_keyType` Type of keys of Map.
    `protected JavaType` | `_valueType` Type of values of Map.

    - ### Fields inherited from class com.fasterxml.jackson.databind.type.TypeBase

      `_bindings, _superClass, _superInterfaces`

    - ### Fields inherited from class com.fasterxml.jackson.databind.JavaType

      `_asStatic, _class, _hash, _typeHandler, _valueHandler`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `MapLikeType(Class<?> mapType, TypeBindings bindings, JavaType superClass, JavaType[] superInts, JavaType keyT, JavaType valueT, Object valueHandler, Object typeHandler, boolean asStatic)`
    `protected` | `MapLikeType(TypeBase base, JavaType keyT, JavaType valueT)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected JavaType` | `_narrow(Class<?> subclass)` Deprecated.
    `protected String` | `buildCanonicalName()`
    `static MapLikeType` | `construct(Class<?> rawType, JavaType keyT, JavaType valueT)` Deprecated.
    `boolean` | `equals(Object o)`
    `JavaType` | `getContentType()`
    `Object` | `getContentTypeHandler()`
    `Object` | `getContentValueHandler()`
    `StringBuilder` | `getErasedSignature(StringBuilder sb)` Method for accessing signature without generic type information, in form compatible with all versions of JVM, and specifically used for type descriptions when generating byte code.
    `StringBuilder` | `getGenericSignature(StringBuilder sb)`
    `JavaType` | `getKeyType()`
    `boolean` | `hasHandlers()` Helper method that checks whether this type, or its (optional) key or content type has `JavaType.getValueHandler()` or `JavaType.getTypeHandler()`; that is, are there any non-standard handlers associated with this type object.
    `boolean` | `isContainerType()`
    `boolean` | `isMapLikeType()`
    `boolean` | `isTrueMapType()` Deprecated. Since 2.12 just use instanceof
    `JavaType` | `refine(Class<?> rawType, TypeBindings bindings, JavaType superClass, JavaType[] superInterfaces)` Mutant factory method that will try to create and return a sub-type instance for known parameterized types; for other types will return `null` to indicate that no just refinement makes necessary sense, without trying to detect special status through implemented interfaces.
    `String` | `toString()`
    `static MapLikeType` | `upgradeFrom(JavaType baseType, JavaType keyT, JavaType valueT)` Factory method that can be used to "upgrade" a basic type into collection-like one; usually done via `TypeModifier`
    `JavaType` | `withContentType(JavaType contentType)` Mutant factory method that may be called on structured types that have a so-called content type (element of arrays, value type of Maps, referenced type of referential types), and will construct a new instance that is identical to this instance, except that it has specified content type, instead of current one.
    `MapLikeType` | `withContentTypeHandler(Object h)` Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified content type (element type for arrays, value type for Maps and so forth) handler assigned.
    `MapLikeType` | `withContentValueHandler(Object h)` Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified content value handler assigned.
    `JavaType` | `withHandlersFrom(JavaType src)` Mutant factory method that will try to copy handlers that the specified source type instance had, if any; this must be done recursively where necessary (as content types may be structured).
    `MapLikeType` | `withKeyType(JavaType keyType)`
    `MapLikeType` | `withKeyTypeHandler(Object h)`
    `MapLikeType` | `withKeyValueHandler(Object h)`
    `MapLikeType` | `withStaticTyping()` Method that can be called to get a type instance that indicates that values of the type should be handled using "static typing" for purposes of serialization (as opposed to "dynamic" aka runtime typing): meaning that no runtime information is needed for determining serializers to use.
    `MapLikeType` | `withTypeHandler(Object h)` "Copy method" that will construct a new instance that is identical to this instance, except that it will have specified type handler assigned.
    `MapLikeType` | `withValueHandler(Object h)` Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified value handler assigned.

    - ### Methods inherited from class com.fasterxml.jackson.databind.type.TypeBase

      `_bogusSuperClass, _classSignature, containedType, containedTypeCount, containedTypeName, findSuperType, findTypeParameters, getBindings, getInterfaces, getSuperClass, serialize, serializeWithType, toCanonical`

    - ### Methods inherited from class com.fasterxml.jackson.databind.JavaType

      `containedTypeOrUnknown, forcedNarrowBy, getErasedSignature, getGenericSignature, getParameterSource, getRawClass, getReferencedType, getTypeHandler, getValueHandler, hasContentType, hasGenericTypes, hashCode, hasRawClass, hasValueHandler, isAbstract, isArrayType, isCollectionLikeType, isConcrete, isEnumImplType, isEnumType, isFinal, isInterface, isJavaLangObject, isPrimitive, isRecordType, isThrowable, isTypeOrSubTypeOf, isTypeOrSuperTypeOf, useStaticType`

    - ### Methods inherited from class com.fasterxml.jackson.core.type.ResolvedType

      `isReferenceType`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.lang.reflect.Type

      `getTypeName`

- - ### Field Detail

    - #### _keyType

          protected final JavaType _keyType

      Type of keys of Map.

    - #### _valueType

          protected final JavaType _valueType

      Type of values of Map.

  - ### Constructor Detail

    - #### MapLikeType

          protected MapLikeType(Class<?> mapType,
                                TypeBindings bindings,
                                JavaType superClass,
                                JavaType[] superInts,
                                JavaType keyT,
                                JavaType valueT,
                                Object valueHandler,
                                Object typeHandler,
                                boolean asStatic)

    - #### MapLikeType

          protected MapLikeType(TypeBase base,
                                JavaType keyT,
                                JavaType valueT)

      Since:
        2.7

  - ### Method Detail

    - #### upgradeFrom

          public static MapLikeType upgradeFrom(JavaType baseType,
                                                JavaType keyT,
                                                JavaType valueT)

      Factory method that can be used to "upgrade" a basic type into collection-like one; usually done via `TypeModifier`
      Since:
        2.7

    - #### construct

          @Deprecated
          public static MapLikeType construct(Class<?> rawType,
                                                          JavaType keyT,
                                                          JavaType valueT)

      Deprecated.

    - #### _narrow

          @Deprecated
          protected JavaType _narrow(Class<?> subclass)

      Deprecated.
      Specified by:
        `_narrow` in class `JavaType`

    - #### withKeyType

          public MapLikeType withKeyType(JavaType keyType)

      Since:
        2.7

    - #### withContentType

          public JavaType withContentType(JavaType contentType)

      Description copied from class: `JavaType`
      Mutant factory method that may be called on structured types that have a so-called content type (element of arrays, value type of Maps, referenced type of referential types), and will construct a new instance that is identical to this instance, except that it has specified content type, instead of current one. If content type is already set to given type, `this` is returned. If type does not have a content type (which is the case with `SimpleType`), `IllegalArgumentException` will be thrown.
      Specified by:
        `withContentType` in class `JavaType`
      Returns:
        Newly created type instance

    - #### withTypeHandler

          public MapLikeType withTypeHandler(Object h)

      Description copied from class: `JavaType`
      "Copy method" that will construct a new instance that is identical to this instance, except that it will have specified type handler assigned.
      Specified by:
        `withTypeHandler` in class `JavaType`
      Returns:
        Newly created type instance

    - #### withContentTypeHandler

          public MapLikeType withContentTypeHandler(Object h)

      Description copied from class: `JavaType`
      Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified content type (element type for arrays, value type for Maps and so forth) handler assigned.
      Specified by:
        `withContentTypeHandler` in class `JavaType`
      Returns:
        Newly created type instance, with given

    - #### withValueHandler

          public MapLikeType withValueHandler(Object h)

      Description copied from class: `JavaType`
      Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified value handler assigned.
      Specified by:
        `withValueHandler` in class `JavaType`
      Returns:
        Newly created type instance

    - #### withContentValueHandler

          public MapLikeType withContentValueHandler(Object h)

      Description copied from class: `JavaType`
      Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified content value handler assigned.
      Specified by:
        `withContentValueHandler` in class `JavaType`
      Returns:
        Newly created type instance

    - #### withHandlersFrom

          public JavaType withHandlersFrom(JavaType src)

      Description copied from class: `JavaType`
      Mutant factory method that will try to copy handlers that the specified source type instance had, if any; this must be done recursively where necessary (as content types may be structured).
      Overrides:
        `withHandlersFrom` in class `JavaType`

    - #### withStaticTyping

          public MapLikeType withStaticTyping()

      Description copied from class: `JavaType`
      Method that can be called to get a type instance that indicates that values of the type should be handled using "static typing" for purposes of serialization (as opposed to "dynamic" aka runtime typing): meaning that no runtime information is needed for determining serializers to use. The main use case is to allow forcing of specific root value serialization type, and specifically in resolving serializers for contained types (element types for arrays, Collections and Maps).
      Specified by:
        `withStaticTyping` in class `JavaType`

    - #### refine

          public JavaType refine(Class<?> rawType,
                                 TypeBindings bindings,
                                 JavaType superClass,
                                 JavaType[] superInterfaces)

      Description copied from class: `JavaType`
      Mutant factory method that will try to create and return a sub-type instance for known parameterized types; for other types will return `null` to indicate that no just refinement makes necessary sense, without trying to detect special status through implemented interfaces.
      Specified by:
        `refine` in class `JavaType`

    - #### buildCanonicalName

          protected String buildCanonicalName()

      Overrides:
        `buildCanonicalName` in class `TypeBase`

    - #### isContainerType

          public boolean isContainerType()

      Specified by:
        `isContainerType` in class `JavaType`
      Returns:
        True if type represented is a container type; this includes array, Map and Collection types.

    - #### isMapLikeType

          public boolean isMapLikeType()

      Overrides:
        `isMapLikeType` in class `JavaType`
      Returns:
        True if type is either true `Map` type, or something similar (meaning it has at least two type parameter; first one describing key type, second value type)

    - #### getKeyType

          public JavaType getKeyType()

      Overrides:
        `getKeyType` in class `JavaType`

    - #### getContentType

          public JavaType getContentType()

      Overrides:
        `getContentType` in class `JavaType`

    - #### getContentValueHandler

          public Object getContentValueHandler()

      Overrides:
        `getContentValueHandler` in class `JavaType`

    - #### getContentTypeHandler

          public Object getContentTypeHandler()

      Overrides:
        `getContentTypeHandler` in class `JavaType`

    - #### hasHandlers

          public boolean hasHandlers()

      Description copied from class: `JavaType`
      Helper method that checks whether this type, or its (optional) key or content type has `JavaType.getValueHandler()` or `JavaType.getTypeHandler()`; that is, are there any non-standard handlers associated with this type object.
      Overrides:
        `hasHandlers` in class `JavaType`

    - #### getErasedSignature

          public StringBuilder getErasedSignature(StringBuilder sb)

      Description copied from class: `JavaType`
      Method for accessing signature without generic type information, in form compatible with all versions of JVM, and specifically used for type descriptions when generating byte code.
      Specified by:
        `getErasedSignature` in class `TypeBase`
      Parameters:
        `sb` - StringBuilder to append signature to
      Returns:
        StringBuilder that was passed in; returned to allow call chaining

    - #### getGenericSignature

          public StringBuilder getGenericSignature(StringBuilder sb)

      Specified by:
        `getGenericSignature` in class `TypeBase`
      Parameters:
        `sb` - StringBuilder to append signature to
      Returns:
        StringBuilder that was passed in; returned to allow call chaining

    - #### withKeyTypeHandler

          public MapLikeType withKeyTypeHandler(Object h)

    - #### withKeyValueHandler

          public MapLikeType withKeyValueHandler(Object h)

    - #### isTrueMapType

          @Deprecated
          public boolean isTrueMapType()

      Deprecated. Since 2.12 just use instanceof
      Method that can be used for checking whether this type is a "real" Collection type; meaning whether it represents a parameterized subtype of `Collection` or just something that acts like one.

    - #### toString

          public String toString()

      Specified by:
        `toString` in class `JavaType`

    - #### equals

          public boolean equals(Object o)

      Specified by:
        `equals` in class `JavaType`

Copyright © 2008–2020 FasterXML. All rights reserved.